package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.UserBalanceLogService;
import com.gxwebsoft.shop.entity.UserBalanceLog;
import com.gxwebsoft.shop.param.UserBalanceLogParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 用户余额变动明细表控制器
 *
 * @author 科技小王子
 * @since 2023-04-21 15:59:09
 */
@Api(tags = "用户余额变动明细表管理")
@RestController
@RequestMapping("/api/shop/user-balance-log")
public class UserBalanceLogController extends BaseController {
    @Resource
    private UserBalanceLogService userBalanceLogService;

    @PreAuthorize("hasAuthority('shop:userBalanceLog:list')")
    @OperationLog
    @ApiOperation("分页查询用户余额变动明细表")
    @GetMapping("/page")
    public ApiResult<PageResult<UserBalanceLog>> page(UserBalanceLogParam param) {
        // 使用关联查询
        return success(userBalanceLogService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userBalanceLog:list')")
    @OperationLog
    @ApiOperation("查询全部用户余额变动明细表")
    @GetMapping()
    public ApiResult<List<UserBalanceLog>> list(UserBalanceLogParam param) {
        PageParam<UserBalanceLog, UserBalanceLogParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(userBalanceLogService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(userBalanceLogService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userBalanceLog:list')")
    @OperationLog
    @ApiOperation("根据id查询用户余额变动明细表")
    @GetMapping("/{id}")
    public ApiResult<UserBalanceLog> get(@PathVariable("id") Integer id) {
        return success(userBalanceLogService.getById(id));
        // 使用关联查询
        //return success(userBalanceLogService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:userBalanceLog:save')")
    @OperationLog
    @ApiOperation("添加用户余额变动明细表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserBalanceLog userBalanceLog) {
        // 记录当前登录用户id、租户id、商户编号
        User loginUser = getLoginUser();
        if (loginUser != null) {
          userBalanceLog.setUserId(loginUser.getUserId());
          userBalanceLog.setMerchantCode(getMerchantCode());
        }
        if (userBalanceLogService.save(userBalanceLog)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userBalanceLog:update')")
    @OperationLog
    @ApiOperation("修改用户余额变动明细表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserBalanceLog userBalanceLog) {
        if (userBalanceLogService.updateById(userBalanceLog)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userBalanceLog:remove')")
    @OperationLog
    @ApiOperation("删除用户余额变动明细表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userBalanceLogService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:userBalanceLog:save')")
    @OperationLog
    @ApiOperation("批量添加用户余额变动明细表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserBalanceLog> list) {
        if (userBalanceLogService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userBalanceLog:update')")
    @OperationLog
    @ApiOperation("批量修改用户余额变动明细表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserBalanceLog> batchParam) {
        if (batchParam.update(userBalanceLogService, "log_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userBalanceLog:remove')")
    @OperationLog
    @ApiOperation("批量删除用户余额变动明细表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userBalanceLogService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
